#ifndef SEGMENT_FUNCTIONS_H
#define	SEGMENT_FUNCTIONS_H
//------------------------------------------------------------------------------
#include "Segments_Pins.h"
#include "Segments_Prototypes.h"
#include "74HC595.h"
//------------------------------------------------------------------------------
void Segment_Init()
{
  D0_dir = 0;
  D1_dir = 0;
  D2_dir = 0;
  D3_dir = 0;
  
  D0 = 0;
  D1 = 0;  
  D2 = 0;
  D3 = 0;
}
//------------------------------------------------------------------------------
void Segment_display(int number)
{    
  char numLen[10];
  char* strNum = itoa(numLen,number,10);    //Change to String - stdlib function
  
  char size = strlen(strNum);
  char offset = 4 - size;
  
  for(int pos=0; pos < size; pos++)
  {
    char index = strNum[pos] - 48;           //Decimal 48 is 0 in ASCII
    
    ShiftReg_Transmit(digit[index]);
    Segment_selectCol(pos + offset);
  }
}
//------------------------------------------------------------------------------
void Segment_selectCol(char digit)
{
  const unsigned int time = 5;
  
  switch(digit)
  {
    case 0: 
            D0 = 1; __delay_ms(time); D0 = 0; break;   //Column 0 (On then Off)
    case 1: 
            D1 = 1; __delay_ms(time); D1 = 0; break;   //Column 1 (On then Off)
    case 2: 
            D2 = 1; __delay_ms(time); D2 = 0; break;   //Column 2 (On then Off)
    case 3: 
            D3 = 1; __delay_ms(time); D3 = 0; break;   //Column 3 (On then Off)                   
  }
}
//------------------------------------------------------------------------------
#endif